/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2016 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

DECLARE

  --
  -- Local constants and variables
  --
  l_SERVICE CONSTANT xxas_com_service_repository.service_name%TYPE
                       := 'TimeAndAbsAutoSetup';

BEGIN

  xxas_com_sr_pkg.set_rest_service
    (p_service_name       => l_SERVICE
    ,p_description        => 'TimeAndAbsAutoSetup'
    ,p_path               => 'time-and-abs-auto-setup'
    ,p_consumes           => 'application/xml'
    ,p_produces           => 'application/xml'
    );
    
  xxas_com_sr_pkg.set_rest_method
    (p_service_name       => l_SERVICE
    ,p_method_name        => 'DoTimeAndAbsAutoSetup'
    ,p_description        => 'Starts Time And Absence AutoSetup'
    ,p_methods            => 'POST'
    ,p_plsql              =>
      q'[
          DECLARE

          l_resp          xxas_http_resp_obj;
          l_return_xml    XMLType;

        BEGIN
        
          IF xxas_wf_role_util_pkg.user_has_role
               ('UMX|XXAS_FUNCTIONAL_CONFIG') = 'N'
          THEN
            l_resp := xxas_http_response
                        .status(xxas_http_resp_status_pkg.unauthorised)
                        .build();
          ELSE

            l_return_xml := xxas_setup_time_pkg.autosetup_handler;

            l_resp := xxas_http_response
                        .ok(l_return_xml)
                        .build();            

          END IF;

          {response} := l_resp;

        END
      ]'
    );
  
END;
/
COMMIT;
EXIT;
